import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;

public class MediaController implements ActionListener, ListSelectionListener {
    MediaView mv = new MediaView(this, this);
    ArrayList<Foto> fotocollection = new ArrayList<>();


    /**
     * Controller - nichts zu tun
     */
    public MediaController() {
        // nichts zu tun
        mv.setPhotoList(getNamesPhoto());
        mv.display();
    }

    /**
     * Aus der Collection mssen alle Namen in ein String[] kopiert werden
     *
     * @return String[] mit allen Namen
     */
    String[] getNamesPhoto() {
        String[] strar = new String[fotocollection.size()];

        for (int i = 0; i < fotocollection.size(); i++) {
            strar[i] = fotocollection.get(i).getName();
        }

        return strar;
    }

    @Override
    /**
     * Actionlistener - muss ausprogrammiert werden
     */
    public void actionPerformed(ActionEvent e) {
        System.out.println(e.getActionCommand());
        if (e.getActionCommand() == "Laden") {
            JFileChooser chooser = new JFileChooser(new File("."));
            FileNameExtensionFilter filter = new FileNameExtensionFilter("Images", "photo");
            chooser.setFileFilter(filter);
            int returnVal = chooser.showOpenDialog(mv);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());

                File myfile = new File(chooser.getSelectedFile().getName());
                try {
                    BufferedReader reader = new BufferedReader(new FileReader(myfile));
                    while (reader.ready()) {
                        String line = reader.readLine();
                        String[] spl = line.split(";");

                        if (spl.length != 6)
                            throw new WrongFileFormatException("invaild number of columns");

                        try {
                            Foto ft = new Foto(spl[0],
                                    Integer.parseInt(spl[1]),
                                    Integer.parseInt(spl[2]),
                                    spl[3],
                                    Integer.parseInt(spl[4]),
                                    Integer.parseInt(spl[5])
                            );

                            fotocollection.add(ft);
                            mv.setPhotoList(getNamesPhoto());
                        } catch (NumberFormatException ee) {
                            throw new WrongFileFormatException("parse error- no integer in file column");
                        }
                    }

                } catch (FileNotFoundException fileNotFoundException) {
                    fileNotFoundException.printStackTrace();
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                } catch (WrongFileFormatException en) {
                    System.err.println("an File Format exception occured: " + en.getMessage());
                    showPopup(en.getMessage());
                }

            }
        } else if (e.getActionCommand() == "Grafik") {
            int raw = 0;
            int jpeg = 0;
            int gif = 0;

            for (Foto ft : fotocollection) {
                switch (ft.getFileformat()) {
                    case "JPEG":
                        jpeg++;
                        break;
                    case "RAW":
                        raw++;
                        break;
                    case "GIF":
                        gif++;
                        break;
                }
            }
            mv.displayGraph(raw, jpeg, gif);
        }

    }

    @Override
    /**
     * ListSelectionListener - wenn sich die
     */
    public void valueChanged(ListSelectionEvent e) {
        Foto ft = fotocollection.get(mv.photoList.getSelectedIndex());

        mv.setData(ft.getFileformat(), ft.getWidth(), ft.getHeight());
    }

    public void showPopup(String message) {
        JDialog dialog = new JDialog(mv, "Title");
        dialog.setSize(200, 200);
        dialog.setLayout(new BorderLayout());
        JButton btn = new JButton("ok");
        btn.addActionListener(e1 -> {
            dialog.setVisible(false);
            dialog.dispose();
        });

        dialog.add(btn, BorderLayout.SOUTH);
        dialog.add(new JLabel(message), BorderLayout.CENTER);
        dialog.setVisible(true);
    }
}
